Lucene++ - a full-featured, c++ search engine
API Documentation

Public Member Functions | Static Public Member Functions
Lucene::NumericRangeFilter Class Reference

A Filter that only accepts numeric values within a specified range. To use this, you must first index the numeric values using NumericField (NumericTokenStream). More...

`#include <NumericRangeFilter.h>`

Inheritance diagram for Lucene::NumericRangeFilter:

## Public Member Functions

| NumericRangeFilter (const NumericRangeQueryPtr &query)
virtual | ~NumericRangeFilter ()
virtual String | getClassName ()
boost::shared_ptr< NumericRangeFilter > | shared_from_this ()
String | getField ()
| Returns the field name for this filter. More...
bool | includesMin ()
| Returns true if the lower endpoint is inclusive. More...
bool | includesMax ()
| Returns true if the upper endpoint is inclusive. More...
NumericValue | getMin ()
| Returns the lower value of this range filter. More...
NumericValue | getMax ()
| Returns the upper value of this range filter. More...
Public Member Functions inherited from Lucene::MultiTermQueryWrapperFilter
virtual | ~MultiTermQueryWrapperFilter ()
boost::shared_ptr< MultiTermQueryWrapperFilter > | shared_from_this ()
virtual String | toString ()
| Returns a string representation of the object. More...
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal. More...
virtual int32_t | hashCode ()
| Return hash code for this object. More...
int32_t | getTotalNumberOfTerms ()
| Return the number of unique terms visited during execution of the filter. If there are many of them, you may consider using another filter type or optimize your total term count in index. More...
void | clearTotalNumberOfTerms ()
| Resets the counting of unique terms. Do this before executing the filter. More...
virtual DocIdSetPtr | getDocIdSet (const IndexReaderPtr &reader)
| Returns a DocIdSet with documents that should be permitted in search results. More...
Public Member Functions inherited from Lucene::Filter
virtual | ~Filter ()
boost::shared_ptr< Filter > | shared_from_this ()
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Return clone of this object. More...
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()
static NumericRangeFilterPtr | newLongRange (const String &field, int32_t precisionStep, int64_t min, int64_t max, bool minInclusive, bool maxInclusive)
| Factory that creates a NumericRangeFilter, that filters a long range using the given precisionStep. More...
static NumericRangeFilterPtr | newLongRange (const String &field, int64_t min, int64_t max, bool minInclusive, bool maxInclusive)
| Factory that creates a NumericRangeFilter, that filters a long range using the default precisionStep NumericUtils#PRECISION_STEP_DEFAULT (4). More...
static NumericRangeFilterPtr | newIntRange (const String &field, int32_t precisionStep, int32_t min, int32_t max, bool minInclusive, bool maxInclusive)
| Factory that creates a NumericRangeFilter, that filters a int range using the given precisionStep. More...
static NumericRangeFilterPtr | newIntRange (const String &field, int32_t min, int32_t max, bool minInclusive, bool maxInclusive)
| Factory that creates a NumericRangeFilter, that filters a int range using the default precisionStep NumericUtils#PRECISION_STEP_DEFAULT (4). More...
static NumericRangeFilterPtr | newDoubleRange (const String &field, int32_t precisionStep, double min, double max, bool minInclusive, bool maxInclusive)
| Factory that creates a NumericRangeFilter, that filters a double range using the given precisionStep. More...
static NumericRangeFilterPtr | newDoubleRange (const String &field, double min, double max, bool minInclusive, bool maxInclusive)
| Factory that creates a NumericRangeFilter, that filters a double range using the default precisionStep NumericUtils#PRECISION_STEP_DEFAULT (4). More...
static NumericRangeFilterPtr | newNumericRange (const String &field, int32_t precisionStep, NumericValue min, NumericValue max, bool minInclusive, bool maxInclusive)
| Factory that creates a NumericRangeFilter, that filters a int, long or double range using the given precisionStep. You can have half-open ranges (which are in fact <= or >= queries) by setting the min or max value to VariantUtils::null(). By setting inclusive to false it will match all documents excluding the bounds, with inclusive on the boundaries are hits, too. More...
static NumericRangeFilterPtr | newNumericRange (const String &field, NumericValue min, NumericValue max, bool minInclusive, bool maxInclusive)

Factory that creates a NumericRangeFilter, that filters a int, long or double range range using the default precisionStep NumericUtils#PRECISION_STEP_DEFAULT (4). You can have half-open ranges (which are in fact <= or >= queries) by setting the min or max value to VariantUtils::null(). By setting inclusive to false it will match all documents excluding the bounds, with inclusive on the boundaries are hits, too. More...

Static Public Member Functions inherited from Lucene::MultiTermQueryWrapperFilter
static String | _getClassName ()
Static Public Member Functions inherited from Lucene::Filter
static String | _getClassName ()

## Additional Inherited Members

Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()
Protected Attributes inherited from Lucene::MultiTermQueryWrapperFilter
MultiTermQueryPtr | query
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Detailed Description

A Filter that only accepts numeric values within a specified range. To use this, you must first index the numeric values using NumericField (NumericTokenStream).

You create a new NumericRangeFilter with the static factory methods, eg:

    FilterPtr f = NumericRangeFilter::newDoubleRange(L"weight", 0.3, 0.10, true, true);

accepts all documents whose double valued "weight" field ranges from 0.3 to 0.10, inclusive.

See NumericRangeQuery for details on how Lucene indexes and searches numeric valued fields.

## Constructor & Destructor Documentation

## ◆ NumericRangeFilter()

Lucene::NumericRangeFilter::NumericRangeFilter | ( | const NumericRangeQueryPtr & | query | ) |

## ◆ ~NumericRangeFilter()

virtual Lucene::NumericRangeFilter::~NumericRangeFilter | ( |  | ) |

virtual

## Member Function Documentation

## ◆ _getClassName()

static String Lucene::NumericRangeFilter::_getClassName | ( |  | ) |

inline static

## ◆ getClassName()

virtual String Lucene::NumericRangeFilter::getClassName | ( |  | ) |

inline virtual

Reimplemented from Lucene::MultiTermQueryWrapperFilter.

## ◆ getField()

String Lucene::NumericRangeFilter::getField | ( |  | ) |

Returns the field name for this filter.

## ◆ getMax()

NumericValue Lucene::NumericRangeFilter::getMax | ( |  | ) |

Returns the upper value of this range filter.

## ◆ getMin()

NumericValue Lucene::NumericRangeFilter::getMin | ( |  | ) |

Returns the lower value of this range filter.

## ◆ includesMax()

bool Lucene::NumericRangeFilter::includesMax | ( |  | ) |

Returns true if the upper endpoint is inclusive.

## ◆ includesMin()

bool Lucene::NumericRangeFilter::includesMin | ( |  | ) |

Returns true if the lower endpoint is inclusive.

## ◆ newDoubleRange() [1/2]

static NumericRangeFilterPtr Lucene::NumericRangeFilter::newDoubleRange | ( | const String & | field,
|  | double | min,
|  | double | max,
|  | bool | minInclusive,
|  | bool | maxInclusive
| ) |  |

static

Factory that creates a NumericRangeFilter, that filters a double range using the default precisionStep NumericUtils#PRECISION_STEP_DEFAULT (4).

## ◆ newDoubleRange() [2/2]

static NumericRangeFilterPtr Lucene::NumericRangeFilter::newDoubleRange | ( | const String & | field,
|  | int32_t | precisionStep,
|  | double | min,
|  | double | max,
|  | bool | minInclusive,
|  | bool | maxInclusive
| ) |  |

static

Factory that creates a NumericRangeFilter, that filters a double range using the given precisionStep.

## ◆ newIntRange() [1/2]

static NumericRangeFilterPtr Lucene::NumericRangeFilter::newIntRange | ( | const String & | field,
|  | int32_t | min,
|  | int32_t | max,
|  | bool | minInclusive,
|  | bool | maxInclusive
| ) |  |

static

Factory that creates a NumericRangeFilter, that filters a int range using the default precisionStep NumericUtils#PRECISION_STEP_DEFAULT (4).

## ◆ newIntRange() [2/2]

static NumericRangeFilterPtr Lucene::NumericRangeFilter::newIntRange | ( | const String & | field,
|  | int32_t | precisionStep,
|  | int32_t | min,
|  | int32_t | max,
|  | bool | minInclusive,
|  | bool | maxInclusive
| ) |  |

static

Factory that creates a NumericRangeFilter, that filters a int range using the given precisionStep.

## ◆ newLongRange() [1/2]

static NumericRangeFilterPtr Lucene::NumericRangeFilter::newLongRange | ( | const String & | field,
|  | int32_t | precisionStep,
|  | int64_t | min,
|  | int64_t | max,
|  | bool | minInclusive,
|  | bool | maxInclusive
| ) |  |

static

Factory that creates a NumericRangeFilter, that filters a long range using the given precisionStep.

## ◆ newLongRange() [2/2]

static NumericRangeFilterPtr Lucene::NumericRangeFilter::newLongRange | ( | const String & | field,
|  | int64_t | min,
|  | int64_t | max,
|  | bool | minInclusive,
|  | bool | maxInclusive
| ) |  |

static

Factory that creates a NumericRangeFilter, that filters a long range using the default precisionStep NumericUtils#PRECISION_STEP_DEFAULT (4).

## ◆ newNumericRange() [1/2]

static NumericRangeFilterPtr Lucene::NumericRangeFilter::newNumericRange | ( | const String & | field,
|  | int32_t | precisionStep,
|  | NumericValue | min,
|  | NumericValue | max,
|  | bool | minInclusive,
|  | bool | maxInclusive
| ) |  |

static

Factory that creates a NumericRangeFilter, that filters a int, long or double range using the given precisionStep. You can have half-open ranges (which are in fact <= or >= queries) by setting the min or max value to VariantUtils::null(). By setting inclusive to false it will match all documents excluding the bounds, with inclusive on the boundaries are hits, too.

## ◆ newNumericRange() [2/2]

static NumericRangeFilterPtr Lucene::NumericRangeFilter::newNumericRange | ( | const String & | field,
|  | NumericValue | min,
|  | NumericValue | max,
|  | bool | minInclusive,
|  | bool | maxInclusive
| ) |  |

static

Factory that creates a NumericRangeFilter, that filters a int, long or double range range using the default precisionStep NumericUtils#PRECISION_STEP_DEFAULT (4). You can have half-open ranges (which are in fact <= or >= queries) by setting the min or max value to VariantUtils::null(). By setting inclusive to false it will match all documents excluding the bounds, with inclusive on the boundaries are hits, too.

## ◆ shared_from_this()

boost::shared_ptr< NumericRangeFilter > Lucene::NumericRangeFilter::shared_from_this | ( |  | ) |

inline

The documentation for this class was generated from the following file:

- NumericRangeFilter.h

clucene.sourceforge.net